unit main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics, Vcl.Imaging.GIFImg,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.ExtDlgs, Vcl.StdCtrls, Vcl.Buttons, Vcl.ExtCtrls, Vcl.ColorGrd, VCLTee.TeCanvas;

type
  TForm1 = class(TForm)
    gbSource: TGroupBox;
    gbMask: TGroupBox;
    imgSource: TImage;
    imgMask: TImage;
    gbResult: TGroupBox;
    imgResult: TImage;
    bbtnSource: TBitBtn;
    bbtnMask: TBitBtn;
    dlgOpenPic1: TOpenPictureDialog;
    procedure bbtnSourceClick(Sender: TObject);
    procedure bbtnMaskClick(Sender: TObject);
  private
    procedure DrawTransparent();
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.bbtnMaskClick(Sender: TObject);
begin
  if dlgOpenPic1.Execute then
  begin
    imgMask.Picture.LoadFromFile(dlgOpenPic1.FileName);
    DrawTransparent();
  end;
end;

procedure TForm1.bbtnSourceClick(Sender: TObject);
begin
  if dlgOpenPic1.Execute then
  begin
    imgSource.Picture.LoadFromFile(dlgOpenPic1.FileName);
  end;
end;

procedure TForm1.DrawTransparent();
var
  GifSource, GifMask: TGifImage;
  bmpSource, bmpResult, bmpMask: TBitmap;
  R: TRect;
begin
  GifSource := TGifImage.Create;
  GifMask   := TGifImage.Create;
  bmpSource := TBitmap.Create;
  bmpMask   := TBitmap.Create;
  bmpResult := TBitmap.Create;
  try
    GifSource.Assign(imgSource.Picture);
    GifMask.Assign(imgMask.Picture);

    bmpSource.Width  := GifSource.Width;
    bmpSource.Height := GifSource.Height;
    bmpSource.Canvas.Draw(0, 0, GifSource.Bitmap);

    R := Rect(0, 0, GifSource.Width, GifSource.Height);
    bmpMask.Width  := GifSource.Width;
    bmpMask.Height := GifSource.Height;
    GifMask.BackgroundColorIndex := 253;     // La valeur est  0... je raffecte la bonne (pour ce masque...) :-/
    bmpMask.Canvas.StretchDraw(R, GifMask.Bitmap);
    bmpMask.Mask(GifMask.BackgroundColor);

    bmpResult.Width  := bmpSource.Width;
    bmpResult.Height := bmpSource.Height;
    bmpResult.Canvas.Draw(0, 0, bmpSource);

    bmpResult.Canvas.CopyMode := cmSrcAnd;
    bmpResult.Canvas.CopyRect(R, bmpMask.Canvas, R);

    imgResult.Picture.Bitmap.Width  := GifSource.Width;
    imgResult.Picture.Bitmap.Height := GifSource.Height;
    imgResult.Picture.Bitmap.Canvas.Draw(0, 0, bmpResult);
  finally
    GifSource.Free;
    GifMask.Free;
    bmpSource.Free;
    bmpResult.Free;
    bmpMask.Free;
  end;
end;

end.
